#|
This file is part of Ordo.

Copyright (C) 2025 Ray Miller

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, version 3.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <https://www.gnu.org/licenses/>.
|#

(define-module (ordo util read-lines)
  #:use-module (ice-9 rdelim)
  #:export (read-lines))

(define (read-lines port)
  "Read lines from port until eof is encountered. Return list of all lines read."
  (define (loop line result)
    (if (eof-object? line)
        (reverse result)
        (loop (read-line port) (cons line result))))
  (loop (read-line port) '()))
